/***************************************************************************
 *Copyright (C) 2006 Assima Ltd. All Rights Reserved.
 *
 * PROJECT:		AICC
 * MODULE:		JAVASCRIPT
 * DESCRIPTION: Aicc Javascript file
 * WRITTEN BY:	P.BOIVENT
 * HISTORY:
 *  This file contains all the functions used to ensure AICC communications
 *	in HTML publish and Active X publish
 ***************************************************************************/

/**
 * CONSTANTS
 */
 
 var WBT_MANAGER = false;


/****************************************************************************
*																			*
*			THIS IS THE AICC COMMUNICATION IMPLEMENTATION PART				*
*																			*
****************************************************************************/

/**Function that actually launches the lesson*/
function LaunchAICC()
	{
	var AICCStatus = "";
	var AICCLocation = "";
	var AICCLocationArray = null;
	var iStartStep = 0;
	/**Get the whole LMS response*/
	theLMSResponse = document.getElementById("LMS_RESPONSE_GET").innerText;
	
	/**we have to parse the string*/
	var AICCDataArray = theLMSResponse.split(" ");
	
	/**Check we have retrieved a valid array*/
	if (AICCDataArray != null && AICCDataArray != "")
		{
		/**Loop on the AICC parameters to get the one we want*/
		for(var i=0; i < AICCDataArray.length; i++)
			{
			/**Is it the lesson status parmater?*/
			var searchStr = "lesson_status=";
			var re= new RegExp(searchStr, "gi");
			var theResult = AICCDataArray[i].match(re);
			if(theResult != null)
				{
				/**Get the lesson status*/
				AICCStatus = AICCDataArray[i].slice(AICCDataArray[i].indexOf("=")+1);
				}
			
			/**Is it the lesson location parameter?*/
			searchStr = "lesson_location=";
			re = new RegExp(searchStr, "gi");
			theResult = AICCDataArray[i].match(re);
			if(theResult != null)
				{
				/**get the lesson location*/
				AICCLocation = AICCDataArray[i].slice(AICCDataArray[i].indexOf("=")+1);
				AICCLocationArray = AICCLocation.split(";")
				}
			}
		}
		
	//alert("Status="+AICCStatus+"; location="+AICCLocation);
	/**We have to parse the status to know if this lesson has been suspended*/
	var theStatusArray = AICCStatus.split(",");
	var bIncomplete = false;
	
	/**Check we have retrieved a valid status array*/
	if (theStatusArray != null && theStatusArray != "")
		{
		/**Now go through all the statuses to check if one of them is the incomplete one*/
		for (var i = 0; i < theStatusArray.length(); i++)
			{
			var theStatus = theStatusArray[i].toLowerCase();
			if (theStatus.substr(0,1) == "i" || theStatus.substr(0,1) == "r")
				bIncomplete = true;
			}
		}

	/**This lesson can be resumed, ask the user if he wants to*/
	if (bIncomplete)	
		{
		/**We have to retrieve the location of the start*/
		//alert("The user wants to resume his session to step" + iStartStep);
		g_nStartStep = AICCLocationArray[0];
		g_nPreviousScore = AICCLocationArray[1];
		
		/**Build the alert box string*/
		var SearchStr = "%d";
		var ReplaceStr = g_nStartStep;
		var re= new RegExp("\\b"+SearchStr+"\\b", "gi");
		var theResumeText = g_sResume.replace(re, ReplaceStr);
		ResumeText.innerText = theResumeText;

		/**Now display the resume alert box*/
		ShowModalPopup("ResumePopup");
		}
	else
		{
		/**Actually launch the lesson*/
		Launch(_NO_RESUME);
		}
	}
	
/**Function that initializes AICC*/
function DoInitializeAICC(theSessionID, theURL)
	{
	/**Fill the AICC GET form*/
	document.forms.GET_PARAM_FORM.action = theURL;
	document.forms.GET_PARAM_FORM.all.aicc_sid.value = theSessionID;
		
	/**Fill the AICC PUT form*/
	document.forms.PUT_PARAM_FORM.action = theURL;
	document.forms.PUT_PARAM_FORM.all.aicc_url.value = theURL;
	document.forms.PUT_PARAM_FORM.all.aicc_sid.value = theSessionID;
	
	/**Fill the AICC EXIT form*/
	document.forms.EXIT_AU_FORM.action = theURL;
	document.forms.EXIT_AU_FORM.all.aicc_url.value = theURL;
	document.forms.EXIT_AU_FORM.all.aicc_sid.value = theSessionID;
	
	/**Post the GET Form to retrieve the AICC information from the LMS*/
	document.forms.GET_PARAM_FORM.submit();
	
	/**Retrieve the parameters and launch the lesson*/
	setTimeout("LaunchAICC();", 1000, "Javascript");
	}
	
/**Function that sends scores and terminates SCORM*/
function DoTerminateAICC(theScore, theCurrentStep, theTotalStep, theSessionTime)
	{
	var theStatus = "";
	var theLocation = "";
	var valScore = 0.0;
	var valCurrentStep = 0.0;
	var valTotalStep = 0.0;

	/**Make sure we have numbers*/
	valScore = (typeof(theScore) != "number")?parseInt(theScore):theScore;
	valCurrentStep = (typeof(theCurrentStep) != "number")?parseInt(theCurrentStep):theCurrentStep;
	valTotalStep = (typeof(theTotalStep) != "number")?parseInt(theTotalStep):theTotalStep;
	
	/**Save the AICC form window*/
	var theAICCWindow = window.opener;
	
	/**Calculate the score*/
	if (g_nPreviousScore != null)
		valScore += parseInt(g_nPreviousScore);
	
	/**Check we have finished the Tutorial*/
	if(theCurrentStep != theTotalStep)
		{
		/**Compose the Status, the lesson is suspended*/
		theStatus = "Suspend";
		/**Compose the location to be able to come back to this point later*/
		theLocation = theCurrentStep+";"+theScore;
		/**if lesson is suspended score to be sent is 0*/
		theScore = 0;
		}
	else
		{
		/**Compose the Status, no flag if normal exit*/
		theStatus = "Completed";
		/**Compose the location*/
		theLocation = "End";
		/**Convert the score into an AICC percentage*/
		if (valTotalStep != 0)
			theScore=Math.round(valScore / valTotalStep);
		}

	/**Build the data string to be sent*/
	if (WBT_MANAGER == true)
		theData = "[core]\r\nlesson_location="+theLocation+"\r\nlesson_status="+theStatus+"\r\nscore="+theScore+"\r\ntime="+theSessionTime;
	else
		theData = "[core]%0D%0Alesson_location%3D"+theLocation+"%0D%0Alesson_status%3D"+theStatus+"%0D%0Ascore%3D"+theScore+"%0D%0Atime%3D"+theSessionTime;
				
	/**Set the correct data value*/
	document.forms.PUT_PARAM_FORM.all.aicc_data.value= theData;
	
	/**Post the Exit AU command*/
	document.forms.EXIT_AU_FORM.all.aicc_data.value= theData;
	
	/**Post the values*/
	document.forms.PUT_PARAM_FORM.submit();
	
	/**Then post the Exit command*/
	document.forms.EXIT_AU_FORM.submit();
	}