/***************************************************************************
 *Copyright (C) 2006 Assima Ltd. All Rights Reserved.
 *
 * PROJECT:		SCORM
 * MODULE:		JAVASCRIPT
 * DESCRIPTION: Scorm Javascript file
 * WRITTEN BY:	
 * HISTORY:
 *  This file contains all the functions used to ensure Scorm communications
 *	in HTML publish and Active X publish
 ***************************************************************************/

/**SCORM CONSTANTS*/
var _SCORM_LESSON_STATUS		= "cmi.core.lesson_status";
var _SCORM_LESSON_LOCATION		= "cmi.core.lesson_location";
var	_SCORM_ENTRY				= "cmi.core.entry";
var _SCORM_EXIT					= "cmi.core.exit";
var _SCORM_SUSPEND_DATA			= "cmi.core.suspend_data";
var _SCORM_STUDENT_ID			= "cmi.core.student_id";
var _SCORM_STUDENT_NAME			= "cmi.core.student_name";
var _SCORM_CREDIT				= "cmi.core.credit";
var _SCORM_SCORE_RAW			= "cmi.core.score.raw";
var _SCORM_SCORE_MAX			= "cmi.core.score.max";
var _SCORM_SCORE_MIN			= "cmi.core.score.min";
var _SCORM_TIME_TOTAL			= "cmi.core.total_time";
var _SCORM_SESSION_TIME			= "cmi.core.session_time";
var _SCORM_MASTERY_SCORE		= "cmi.student_data.mastery_score";

var _SCORM_STATUS_FAILED		= "failed";
var _SCORM_STATUS_INCOMPLETE	= "incomplete";
var _SCORM_STATUS_PASSED		= "passed";
var _SCORM_STATUS_COMPLETED		= "completed";
var _SCORM_ENTRY_INITIAL		= "ab-initio";
var _SCORM_ENTRY_RESUME			= "resume";
var _SCORM_EXIT_SUSPEND			= "suspend";


/****************************************************************************
*																			*
*			THIS IS THE SCORM COMMUNICATION IMPLEMENTATION PART				*
*																			*
****************************************************************************/

/**Function that initializes SCORM*/
function DoInitializeSCORM()
	{
	var iStartStep = 0;
	
	/* Check if we need to initialize. */
	if (theOpenerTop.oSCORM && theOpenerTop.oSCORM.init)
		return 0;
	
	/**Initialize*/
	var theResult = doLMSInitialize();
	
	/**Check the initialization has been successfull*/
	if(theResult == true || theResult == "true")
		{
		
		/**create a SCORM object to store info*/
		theOpenerTop.oSCORM = new Object();
		
		/**Get SCORM INFO*/
		theOpenerTop.oSCORM.student_id	= doLMSGetValue(_SCORM_STUDENT_ID);
		theOpenerTop.oSCORM.student_name	= doLMSGetValue(_SCORM_STUDENT_NAME);
		theOpenerTop.oSCORM.credit		= doLMSGetValue(_SCORM_CREDIT);
		theOpenerTop.oSCORM.lesson_status = doLMSGetValue(_SCORM_LESSON_STATUS);
		theOpenerTop.oSCORM.score_raw		= doLMSGetValue(_SCORM_SCORE_RAW);
		theOpenerTop.oSCORM.total_time	= doLMSGetValue(_SCORM_TIME_TOTAL);
		theOpenerTop.oSCORM.mastery_score	= doLMSGetValue(_SCORM_MASTERY_SCORE);
		
		/**
		*RTC fix
		*/
		/**If we don't receive any max value set it at 100*/
		theOpenerTop.oSCORM.score_max		= doLMSGetValue(_SCORM_SCORE_MAX);
		if(theOpenerTop.oSCORM.score_max == "")
			theOpenerTop.oSCORM.score_max = 100;
		
		theOpenerTop.oSCORM.score_min		= doLMSGetValue(_SCORM_SCORE_MIN);
		/**If we don't receive any min value set it at 0*/
		if(theOpenerTop.oSCORM.score_min == "")
			theOpenerTop.oSCORM.score_min = 0;
		/**End of RTC fix*/

		/**Get the Entry Status*/
		var theEntryStatus = doLMSGetValue(_SCORM_ENTRY);
		/**Retrieve the previous location*/
		var sLocation = doLMSGetValue(_SCORM_LESSON_LOCATION);
		
		/**Commit the Data*/
		doLMSCommit();
		
		/**Mark oSCORM as initialized*/
		theOpenerTop.oSCORM.init=true;

		/**Can this simulation be resumed?*/
		if(theEntryStatus == _SCORM_ENTRY_RESUME)
			{	
			/**We have to parse the string to get the different information, store parameters in an array*/
			var ParamArray = sLocation.split(";");
			/**Save the resuming parameters*/
			g_nStartStep = ParamArray[0];
			g_nPreviousScore = ParamArray[1];
			
			/**Build the alert box string*/
			var SearchStr = "0";
			var ReplaceStr = g_nStartStep;
			var re= new RegExp("\\b"+SearchStr+"\\b", "gi");
			var theResumeText = g_sResume.replace(re, ReplaceStr);
			ResumeText.innerHTML = theResumeText;
			ResumeStepText.innertText += g_nStartStep; 

			/**Now display the resume alert box*/
			ShowModalPopup("ResumePopup");
			/**And hide the start message*/
			StartingDIV.style.display="none";
			}
		else
			{
			/**The user doesn't want to resume the lesson, so start a new one from the Beggining*/
			//alert("The user wants to start the lesson again");
			Launch(_NO_RESUME);
			}
		}
	}
	
/**Function that sends scores and terminates SCORM*/
function DoTerminateSCORM(theScore, theCurrentStep, theTotalStep, theSessionTime)
	{
	var valScore = 0.0;
	var valCurrentStep = 0.0;
	var valTotalStep = 0.0;
	var bCreditMode = (theOpenerTop.oSCORM.credit == "credit");
	
	valScore = parseInt(theScore);
		
	/* Get current step value. */	
	valCurrentStep = (typeof(theCurrentStep) != "number")?parseInt(theCurrentStep):theCurrentStep;
	
	/* Get total step value. */
	valTotalStep = (typeof(theTotalStep) != "number")?parseInt(theTotalStep):theTotalStep;
		
	/**Test for the SCORM API Wrapper*/
	if(!theOpenerTop.oSCORM || theOpenerTop.oSCORM.init==false)
		return 0;

	/**Stop any other SCORM from Processing*/
	theOpenerTop.oSCORM.init = false;

	/**Calculate the new score*/
	if (g_nPreviousScore != null)
		{
		valScore += parseInt(g_nPreviousScore);
		//alert(valScore);
		}
	/**Set lesson_status */
	if(valCurrentStep != valTotalStep)
		{
		//alert("User has not finished lesson");
		/**The user has not finished the lesson*/
		doLMSSetValue(_SCORM_LESSON_STATUS,_SCORM_STATUS_INCOMPLETE);
		/**Seet the exit state to suspended*/
		//alert("Last Step "+theCurrentStep);
		doLMSSetValue(_SCORM_EXIT,_SCORM_EXIT_SUSPEND);
		/**We can save the exit point, so the user will get back there nex time*/
		doLMSSetValue(_SCORM_LESSON_LOCATION,theCurrentStep+";"+valScore);
		
		/* Only send score for unfinished lesson if not in credit mode. */
		if (!bCreditMode)
			doLMSSetValue(_SCORM_SCORE_RAW, 0);
		}
	else
		{			
		/**Convert the score into a SCORM percentage*/
		if (valTotalStep != 0)
			{
			/**In activeX steps are not counted in the same way as webInt or JavaLoader*/
			if (!g_bActiveX)
				valTotalStep--;
			theScore = Math.round(valScore / valTotalStep);
			}			
		/**Set Score*/
		doLMSSetValue(_SCORM_SCORE_RAW,theScore);
		
		/* Now set the lesson status depending on credit mode and mastery score. */
		var valMasteryScore = 0;
		if (theOpenerTop.oSCORM.mastery_score != "")
			valMasteryScore = (typeof(theOpenerTop.oSCORM.mastery_score) != "number")?parseInt(theOpenerTop.oSCORM.mastery_score):theOpenerTop.oSCORM.mastery_score;
		/* Is the current score higher than the mastery one? */			
		if (theScore >= valMasteryScore)
			{
			/* Then it's either passed or completed depending on credit mode. */
			if (bCreditMode)
				doLMSSetValue(_SCORM_LESSON_STATUS,_SCORM_STATUS_PASSED);
			else
				doLMSSetValue(_SCORM_LESSON_STATUS,_SCORM_STATUS_COMPLETED);
			}
		else
			{
			/* It's failed. */
			doLMSSetValue(_SCORM_LESSON_STATUS,_SCORM_STATUS_FAILED);
			}
		}
	
	/** score max */
	doLMSSetValue(_SCORM_SCORE_MAX,theOpenerTop.oSCORM.score_max);
	
	/** score min */
	doLMSSetValue(_SCORM_SCORE_MIN,theOpenerTop.oSCORM.score_min);
	
	/**session time*/
	doLMSSetValue(_SCORM_SESSION_TIME,theSessionTime);
	
	/* commit all the result */
	doLMSCommit();
	
	/**Terminate SCORM*/
	doLMSFinish();
	}
